
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 0.9d
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_STUBENTRY_HPP
#define INCLUDE_RCF_STUBENTRY_HPP

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

#include <RCF/Export.hpp>
#include <RCF/ThreadLibrary.hpp>

namespace RCF {

    class                                       I_RcfClient;
    class                                       StubEntry;
    typedef boost::shared_ptr<I_RcfClient>      RcfClientPtr;
    typedef boost::shared_ptr<StubEntry>        StubEntryPtr;

    class RCF_EXPORT StubEntry : boost::noncopyable
    {
    public:
        StubEntry(const RcfClientPtr &rcfClientPtr);

        RcfClientPtr    getRcfClientPtr() const;
        void            touch();
        unsigned int    getElapsedTimeS() const;

    private:
        RcfClientPtr    mRcfClientPtr;
        mutable Mutex   mMutex;
        unsigned int    mTimeStamp;
    };

} // namespace RCF

#endif // ! INCLUDE_RCF_STUBENTRY_HPP
