
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 0.9d
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_THREADLOCALDATA_HPP
#define INCLUDE_RCF_THREADLOCALDATA_HPP

#include <boost/shared_ptr.hpp>

#include <RCF/Export.hpp>

namespace RCF {

    class ObjectCache;
    class ClientStub;
    class I_Session;
    class RcfSession;
    class ThreadInfo;

    typedef boost::shared_ptr<ClientStub> ClientStubPtr;
    typedef boost::shared_ptr<I_Session> SessionPtr;
    typedef boost::shared_ptr<RcfSession> RcfSessionPtr;
    typedef boost::shared_ptr<ThreadInfo> ThreadInfoPtr;

    RCF_EXPORT ObjectCache &   getThreadLocalObjectCache();
    RCF_EXPORT ClientStubPtr   getCurrentClientStubPtr();
    RCF_EXPORT void            setCurrentClientStubPtr(ClientStubPtr clientStubPtr);
    RCF_EXPORT RcfSessionPtr   getCurrentRcfSessionPtr();
    RCF_EXPORT void            setCurrentRcfSessionPtr(const RcfSessionPtr &rcfSessionPtr = RcfSessionPtr());
    RCF_EXPORT ThreadInfoPtr   getThreadInfoPtr();
    RCF_EXPORT void            setThreadInfoPtr(const ThreadInfoPtr &threadInfoPtr);
    RCF_EXPORT SessionPtr      getCurrentUdpSessionPtr();
    RCF_EXPORT void            setCurrentUdpSessionPtr(SessionPtr sessionPtr);

} // namespace RCF

#endif // ! INCLUDE_RCF_THREADLOCALDATA_HPP
