
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 0.9d
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_WIN32NAMEDPIPECLIENTTRANSPORT_HPP
#define INCLUDE_RCF_WIN32NAMEDPIPECLIENTTRANSPORT_HPP

#include <RCF/ClientTransport.hpp>
#include <RCF/Export.hpp>

#include <RCF/util/Tchar.hpp>
#include "tchar.h"

namespace RCF {

    class RCF_EXPORT Win32NamedPipeClientTransport : 
        public I_ClientTransport
    {
    public:

        Win32NamedPipeClientTransport(
            const Win32NamedPipeClientTransport & rhs);

        Win32NamedPipeClientTransport(
            const tstring & pipeName, 
            const tstring & machine = _T(""));

        ~Win32NamedPipeClientTransport();
        ClientTransportAutoPtr clone() const;
        EndpointPtr getEndpointPtr() const;
        int send(const std::vector<ByteBuffer> &data, unsigned int timeoutMs);
        void timedReceive(char *buffer, std::size_t len, unsigned int endTimeMs);
        int receive(ByteBuffer &byteBuffer, unsigned int timeoutMs);
        bool isConnected();
        void connect(unsigned int timeoutMs);
        void disconnect(unsigned int timeoutMs = 0);
        void setTransportFilters(const std::vector<FilterPtr> &filters);
        void getTransportFilters(std::vector<FilterPtr> &filters);

    private:
        tstring mPipeName;
        HANDLE mhPipe;
        HANDLE mhEvent;

        boost::shared_ptr< std::vector<char> > mReadBufferPtr;
    };

} // namespace RCF

#endif // ! INCLUDE_RCF_WIN32NAMEDPIPECLIENTTRANSPORT_HPP
