
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 0.9d
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_WIN32NAMEDPIPEENDPOINT_HPP
#define INCLUDE_RCF_WIN32NAMEDPIPEENDPOINT_HPP

#include <RCF/Endpoint.hpp>
#include <RCF/Export.hpp>
#include <RCF/ClientTransport.hpp>
#include <RCF/ServerTransport.hpp>

#include <SF/SerializeParent.hpp>

#include <RCF/util/Tchar.hpp>
#include <tchar.h>

namespace RCF {

    class RCF_EXPORT Win32NamedPipeEndpoint : public I_Endpoint
    {
    public:

        Win32NamedPipeEndpoint();

        Win32NamedPipeEndpoint(
            const tstring & pipeName, 
            const tstring & machine = _T(""));

        ServerTransportAutoPtr createServerTransport() const;
        ClientTransportAutoPtr createClientTransport() const;
        EndpointPtr clone() const;

        template<typename Archive>
        void serialize(Archive &ar, const unsigned int)
        {
            serializeParent( (I_Endpoint*) 0, ar, *this);
            ar & mPipeName;
        }

    private:
        tstring mPipeName;
        tstring mMachine;
    };

    RCF_EXPORT tstring generateNewPipeName();

} // namespace RCF

RCF_BROKEN_COMPILER_TYPE_TRAITS_SPECIALIZATION(RCF::Win32NamedPipeEndpoint)

#endif // ! INCLUDE_RCF_WIN32NAMEDPIPEENDPOINT_HPP
