
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 0.9d
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_TEST_DISABLBEGPFDIALOG_HPP
#define INCLUDE_RCF_TEST_DISABLBEGPFDIALOG_HPP

#include <boost/config.hpp>

#include <RCF/util/CommandLine.hpp>

class GpfDialogCommandLineOption : public util::CommandLineOption<bool>
{
public:

    GpfDialogCommandLineOption() :
        util::CommandLineOption<bool>("gpfdialog", false, "Enable or disable display of GPF dialog.")
    {}

#ifdef BOOST_WINDOWS

    void on_notify_end()
    {
        bool enableGpfDialog = get();
        if (!enableGpfDialog)
        {
            DWORD dwFlags = SEM_NOGPFAULTERRORBOX | SEM_FAILCRITICALERRORS;
            DWORD dwOldFlags = SetErrorMode(dwFlags);
            SetErrorMode(dwOldFlags | dwFlags);
        }
    }

#else

    void on_notify_end()
    {}

#endif

};

GpfDialogCommandLineOption *gdClo = NULL;

UTIL_ON_INIT_NAMED( gdClo = new GpfDialogCommandLineOption(); , PtoCloInitialize )

#endif // ! INCLUDE_RCF_TEST_DISABLBEGPFDIALOG_HPP
